wpPrefix = 'w-'

wpCount = 0
for i=1,10000,1 do
	local z = wpPrefix..i
	local zn = trigger.misc.getZone(z)
	if not zn then
		wpCount = i - 1
		break
	end
end


function mag(vec)
	return (vec.x^2 + vec.y^2 + vec.z^2)^0.5
end
	
function makeVec3(vec, y)
	if not vec.z then
		if vec.alt and not y then
			y = vec.alt
		elseif not y then
			y = 0
		end
		return {x = vec.x, y = y, z = vec.y}
	else
		return {x = vec.x, y = vec.y, z = vec.z}
	end
end

function getDist(point1, point2)
	return mag({x = point1.x - point2.x, y = point1.y - point2.y, z = point1.z - point2.z})
end

function getPointOnSurface(point)
	return {x = point.x, y = land.getHeight({x = point.x, y = point.z}), z= point.z}
end

timer.scheduleFunction(function(param, time)
	for i=1,wpCount,1 do
		local z = wpPrefix..i
		local zn = trigger.misc.getZone(z)
		
		local p = getPointOnSurface(zn.point)
		
		trigger.action.smoke(p, (i%3)+1)
	end
	
	return time+290
end,{},timer.getTime()+2)

playerBest = {}
pdata = {}
bestPl = nil
--nextWp = 1
--doneWp = 0
--startTime = 0
--endTime = 0
timer.scheduleFunction(function(param,time)
	local players = coalition.getPlayers(2)
	for i,v in ipairs(players) do
		local pl = v
		
		local pname = pl:getPlayerName()
		local ptype = pl:getDesc().typeName
		
		local nextWp = pdata[pname].nextWp
		local doneWp = pdata[pname].doneWp
		local startTime = pdata[pname].startTime
		local endTime = pdata[pname].endTime
		
		local pd = pl:getPoint()
		for i=nextWp,wpCount,1 do
			local z = wpPrefix..i
			local zn = trigger.misc.getZone(z)
			local p = getPointOnSurface(zn.point)
			local d = getDist(pd, p)
			if d <= zn.radius then
				doneWp = doneWp + 1
				
				if i == 1 then
					--first wp
					startTime = time
					trigger.action.outText('['..doneWp..'/67]['..z..'] started.\n\nName: '..pname..'\nAircraft: '..ptype,5)
					nextWp = 2
				elseif i == 67 then
					--last wp
					endTime = time
					
					local runTime = endTime-startTime
					trigger.action.outText('['..doneWp..'/67]['..z..'] ended.\n\nName: '..pname..'\nTime: '..endTime-startTime..' sec\nAircraft: '..ptype,60)
					
					if playerBest[pname] == nil then
						trigger.action.outText('New personal best (since mission start).\nPlayer: '..pname..'\nTime: '..runTime,60)
						playerBest[pname] = {time = runTime, type = ptype}
					elseif runTime < playerBest[pname].time then
						trigger.action.outText('New personal best (since mission start).\nPlayer: '..pname..'\nTime: '..runTime..'\n-'..playerBest[pname].time - runTime..'sec',60)
						playerBest[pname] = {time = runTime, type = ptype}
					end
					
					if bestPl == nil or runTime < bestPl.time then
						bestPl = {name = pname, time = runTime, aircraft = ptype}
						trigger.action.outText('New leader(since mission start).\nPlayer: '..pname..'\nTime: '..runTime..'\nAircraft: '..ptype,60)
					end
					
					nextWp = nextWp+1
				elseif i ~= nextWp then
					nextWp = i+1 -- missed wp
					trigger.action.outTextForUnit(pl:getID(),'['..doneWp..'/67]['..z..'] WP missed.\n\nName: '..pname..'\nTime: '..time-startTime..' sec\nAircraft: '..ptype,5)
				else
					nextWp = nextWp+1
					trigger.action.outTextForUnit(pl:getID(),'['..doneWp..'/67]['..z..']\n\nName: '..pname..'\nTime: '..time-startTime..' sec\nAircraft: '..ptype,5)
				end
				
				break
			end
		end
		
		pdata[pname].nextWp = nextWp
		pdata[pname].doneWp = doneWp
		pdata[pname].startTime = startTime
		pdata[pname].endTime = endTime
	end
	
	
	return time+0.1
end,{},timer.getTime()+2)

local ev = {}
function ev:onEvent(event)
	if (event.id==20 or event.id==15) and event.initiator and event.initiator.getPlayerName then
		local pname = event.initiator:getPlayerName()
		if pname then
			pdata[pname] = {nextWp = 1, doneWp = 0, startTime = 0, endTime = 0}
		end
	end
end

world.addEventHandler(ev)

missionCommands.addCommand('Show leaderboard', nil, function()
	local sorted = {}

	for i,v in pairs(playerBest) do table.insert(sorted,{i,v}) end
	
	table.sort(sorted, function(a,b) return a[2].time< b[2].time end)
	
	local outstr = "Leaderboard"
	for i,v in ipairs(sorted) do
		outstr = outstr..'\n'..i..'. '..v[1]..' ['..v[2].type..'] '..v[2].time..' sec'
	end
	
	trigger.action.outText(outstr, 30)
end)